function [n1,m0] = meanfield(n0,alpha,beta,W,obs,hid,Mm,Mn,Nsteps);

if nargin<9, Nsteps = 1; end

if size(alpha,2) ~= size(n0,2), 
    alpha = repmat(alpha,1,size(n0,2));
end
if size(beta,2) ~= size(n0,2), 
    beta = repmat(beta,1,size(n0,2));
end


if strcmp(obs,'binom') && strcmp(hid,'binom')
    n1 = n0;
    for i=1:Nsteps
	m0 = Mm * sigmoid(beta+W*n1);
	n1 = Mn * sigmoid(alpha+W'*m0);
    end

elseif strcmp(obs,'poisson') && strcmp(hid,'binom')
    n1 = n0;
    for i=1:Nsteps
	m0 = Mm * sigmoid(beta+W*n1);
	%n1 = mexexp(alpha+W'*m0);
	n1 = exp(alpha+W'*m0);
    end
end

