
% load Term/Frequency matrix
load('20News_w100','Xtrain');

Nhidden = 10;  % number of hidden units

%modeltype = '2layer_mf';  % Mean Field version of learning
modeltype = '2layer_sampling';  % Gibbs sampling

filename = '20News_10hidden.model'; % file to save the model in
Mm = 1;  % number of states of hidden variable
Nupdates = 1000; % number of updates (-1 for inifite updates)
observed = 'poisson'; % or observed = 'binomial';
Mn = 1; % only relevant for binomial observed variable
Ncdsteps = 1;  % number of steps of Contrastive Divergence

[Nwords,Ntrain] = size(Xtrain);

% learning rates
etaW = 1e-2
etaBeta = 1e-2
etaAlpha = 1e-2

% let the function initialize the parameters to sensible values
W = [];
alpha = [];
beta = [];

[alpha,beta,W] = rap_learn(Xtrain,modeltype,Nhidden,alpha,beta,W,'momAlpha',.99,'momBeta',.99,'momW',.99,'rB',1,'Mm',Mm,'etaAlpha',etaAlpha,'etaBeta',etaBeta,'etaW',etaW,'observed',observed,'Mn',Mn,'sfile',filename,'nU',Nupdates,'nCdsteps',Ncdsteps);

